module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = __webpack_require__(1);

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = __webpack_require__(2);

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var both = (function () {

	  var Both = undefined;

	  // Both should be avaible as function as well as object
	  Both = __webpack_require__(3);

	  // Register-Module which manage the registery
	  Both._globalRegistery = {};
	  Both.register = __webpack_require__(4);

	  // Command-Module to register commands
	  Both.command = __webpack_require__(5);

	  // Query-Module to register queries
	  Both.query = __webpack_require__(6);

	  // On-Module to register command-listeners
	  Both.on = __webpack_require__(7);

	  // Middleware-Module for third-party modules
	  Both.use = __webpack_require__(8);

	  // Registery
	  Both.registery = {
	    commands: {},
	    listeners: {},
	    queries: {} };

	  return Both;
	})();

	module.exports = both;

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = __webpack_require__(11);

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = __webpack_require__(10);

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = __webpack_require__(12);

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = __webpack_require__(9);

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = __webpack_require__(14);

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = __webpack_require__(13);

/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var query = function query() {
	  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	    args[_key] = arguments[_key];
	  }

	  var both = __webpack_require__(1);

	  var queryName = null;
	  var queryFn = null;

	  if (args.length < 2) {
	    throw new Error('[both] the `query` module expects a `queryName` and a `commandFunction`');
	  } else {
	    queryName = args[0];
	    queryFn = args[1];
	  }

	  if (typeof queryName !== 'string') {
	    throw new Error('[both] the `query` module expects a `queryName` in a string format');
	  }

	  if (typeof queryFn !== 'function') {
	    throw new Error('[both] the `query` module expects the `queryFn` as function');
	  }

	  // Register function in Both-Registery
	  both.register('query', {
	    name: queryName,
	    func: queryFn
	  });
	};

	module.exports = query;

/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var register = function register() {
	  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	    args[_key] = arguments[_key];
	  }

	  var both = __webpack_require__(1);
	  var registerType = null;
	  var registerName = null;
	  var registerPayload = null;

	  // Error Handling
	  if (args.length < 2) {
	    throw new Error('[both] the `register` module expects at least two arguments');
	  }

	  if (typeof args[0] !== 'string') {
	    throw new Error('[both] the `register`module expects as first argument a registerType in string-format');
	  } else {
	    registerType = args[0];
	  }

	  if (args[1].toString() !== '[object Object]') {
	    throw new Error('[both] the `register` module expects as second argument a object');
	  } else {
	    registerPayload = args[1];
	  }

	  if (registerPayload.name === undefined) {
	    throw new Error('[both] the `register` module expets at least one `name` param in the given `registerObject`');
	  } else {
	    registerName = registerPayload.name;
	  }

	  // Module
	  both._globalRegistery[registerType] = both._globalRegistery[registerType] || {};
	  both._globalRegistery[registerType][registerName] = registerPayload;
	};

	module.exports = register;

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var execute = function execute() {
	  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	    args[_key] = arguments[_key];
	  }

	  var both = __webpack_require__(1);
	  var methodName = args[0] || false;
	  var methodOptional = args[1] || {};
	  var methodCallback = args[2] || false;

	  // Error Handling
	  if (args.length === 0) {
	    throw new Error('[both] to execute a command you should give us a identifier');
	  }

	  if (args.length > 3) {
	    throw new Error('[both] the execute command doesnt permit more than two arguments');
	  }

	  if (typeof methodName !== 'string') {
	    throw new Error('[both] to execute a command you should give us a string-identifier');
	  }

	  if (typeof methodOptional !== 'object') {
	    throw new Error('[both] the second argument when you execute a command should always be a object or a');
	  }

	  if (typeof methodCallback !== 'function' && methodCallback !== false) {
	    throw new Error('[both] to execute a command you should give us a function as callback');
	  }

	  // Execute commands
	  if (both._globalRegistery.command && both._globalRegistery.command[methodName] !== undefined) {
	    both._globalRegistery.command[methodName].func(methodName, methodOptional, methodCallback);
	  }

	  // Execute listeners
	  if (both._globalRegistery.listener && both._globalRegistery.listener[methodName] !== undefined) {
	    both._globalRegistery.listener[methodName].func(methodName, methodOptional, methodCallback);
	  }

	  // Execute queries
	  if (both._globalRegistery.query && both._globalRegistery.query[methodName] !== undefined) {
	    both._globalRegistery.query[methodName].func(methodName, methodOptional, methodCallback);
	  }

	  // Execute global listeners
	  if (both._globalRegistery.listener) {
	    Object.keys(both._globalRegistery.listener).forEach(function (listenerName) {
	      if (isNaN(listenerName) === false) {
	        both._globalRegistery.listener[listenerName].func(methodName, methodOptional, methodCallback);
	      }
	    });
	  }
	};

	module.exports = execute;

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var command = function command(commandName, commandFn) {

	  var both = __webpack_require__(1);

	  // Error Handling
	  if (commandName === undefined && commandFn === undefined) {
	    throw new Error('[both] the `command` module expects a commandName and a commandFunction');
	  }

	  if (typeof commandName !== 'string') {
	    throw new Error('[both] the `command` module expects a commandName as string');
	  }

	  if (commandFn === undefined) {
	    throw new Error('[both] the `command` module expects a function as second argument');
	  }

	  if (typeof commandFn !== 'function') {
	    throw new Error('[both] the `command` module expects a function as second argument');
	  }

	  both.register('command', {
	    name: commandName,
	    func: commandFn
	  });
	};

	module.exports = command;

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var use = function use() {
	  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	    args[_key] = arguments[_key];
	  }

	  // Register available middlewares
	  var middlewareCollection = {
	    'socket.io': {
	      'server': __webpack_require__(15),
	      'client': __webpack_require__(16)
	    }
	  };

	  var middlewareName = null;
	  var middlewareUnit = null;
	  var middlewareType = null;

	  // Error handling
	  if (args.length === 0) {
	    throw new Error('[both] the `use` adapter expects two arguments [middlewareName, middleware]');
	  }

	  if (typeof args[0] !== 'string') {
	    throw new Error('[both] the `use` adapter expects a [middlewareName]-String as first argument.');
	  } else {
	    middlewareName = args[0];
	  }

	  if (typeof args[1] === 'undefined') {
	    throw new Error('[both] the `use` adapter expects a [middleware] as second argument');
	  } else {
	    middlewareUnit = args[1];
	  }

	  // Check if client or server
	  if (typeof window !== 'undefined' && window) {
	    middlewareType = 'client';
	  } else {
	    middlewareType = 'server';
	  }

	  if (middlewareCollection[middlewareName] !== undefined && middlewareCollection[middlewareName][middlewareType] !== undefined) {
	    middlewareCollection[middlewareName][middlewareType](middlewareUnit);
	  } else {
	    throw new Error('[both] the `use` adapter didnt found any requested modules');
	  }
	};

	module.exports = use;

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var on = function on() {
	  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	    args[_key] = arguments[_key];
	  }

	  var both = __webpack_require__(1);
	  var listeners = both.registery.listeners || {};

	  // Error Handling
	  if (args.length > 2) {
	    throw new Error('[both] the `on` listener allow not more than two params');
	  }

	  if (args.length === 1 && typeof args[0] !== 'function') {
	    throw new Error('[both] the `on` expects at least one function passed');
	  }

	  if (args.length === 0) {
	    throw new Error('[both] the `on` expects some params, read the docs ;)');
	  }

	  // Module
	  if (args.length === 1 && typeof args[0] === 'function') {

	    var listenerID = 0;

	    if (both._globalRegistery.listener) {
	      listenerID = Object.keys(both._globalRegistery.listener).length === 0 ? 0 : Object.keys(listeners).length;
	    }

	    both.register('listener', {
	      name: listenerID,
	      func: args[0]
	    });
	  }

	  if (args.length === 2 && typeof args[0] === 'string' && typeof args[1] === 'function') {
	    var listenerID = args[0];

	    both.register('listener', {
	      name: listenerID,
	      func: args[1]
	    });
	  }
	};

	module.exports = on;

/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var both = __webpack_require__(1);

	module.exports = function (socket) {
	  if (socket !== 'undefined' && socket.on) {
	    socket.on('connection', function (io) {
	      io.on('both', function (args) {
	        var callback = arguments[1] === undefined ? false : arguments[1];

	        var commandName = args.commandName;
	        var payload = args.payload;
	        both(commandName, payload, callback);
	      });
	    });
	  }
	};

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var both = __webpack_require__(1);

	module.exports = function (socket) {
	  if (socket !== 'undefined' && typeof socket === 'function') {
	    both.on(function (commandName, payload, callback) {
	      socket().emit('both', {
	        commandName: commandName,
	        payload: payload
	      }, callback);
	    });
	  }
	};

/***/ }
/******/ ]);